<?php

$full_path = $_SERVER['REQUEST_URI'];
$file_path = urldecode(parse_url($_SERVER['REQUEST_URI'])['path']);
$filename = realpath($_SERVER['DOCUMENT_ROOT'].$file_path);

$debug_log = 0;

if ($debug_log) {
  error_log("full_path $full_path");
  error_log("file_path $file_path");
  error_log("filename $filename");
}

if ($filename === FALSE) {
  return Header( "HTTP/1.1 404 Not Found" );
}

if (strpos($filename, __DIR__) !== 0) {
  return Header( "HTTP/1.1 400 Bad Request" );
}

if ($filename === __DIR__) {
  $filename = "index.html";
}

if ($debug_log) {
  error_log("filename $filename");
}

$contents = file_get_contents($filename);
if ($contents === FALSE) {
  return Header( "HTTP/1.1 404 Not Found" );
}
$file_hash = md5($contents);

if (array_key_exists("hash", $_GET)) {
  $hash = $_GET['hash'];
  if ($hash != $file_hash) {
    return Header( "HTTP/1.1 404 Not Found" );
  }
  header("Cache-Control: max-age=31536000");
} elseif (preg_match("/choicescript_portrait(_large)?\.jpg$/", $filename)) {
  header("Cache-Control: max-age=7200");
} else {
  header("Cache-Control: max-age=0, must-revalidate");
}

if (preg_match("/manifest\.appcache$/", $filename) && preg_match("/CoGnibus/", $_SERVER['HTTP_USER_AGENT'])) {
  return Header( "HTTP/1.1 404 Not Found" );
}

if (preg_match("/\.js$/", $filename)) {
  header("Content-Type: application/javascript");
} else if (preg_match("/\.css$/", $filename)) {
  header("Content-Type: text/css");
} else if (preg_match("/\.gif$/", $filename)) {
  header("Content-Type: image/gif");
} else if (preg_match("/\.png$/", $filename)) {
  header("Content-Type: image/png");
} else if (preg_match("/\.jpg$/", $filename)) {
  header("Content-Type: image/jpeg");
} else if (preg_match("/\.html$/", $filename)) {
  header("Content-Type: text/html");
} else if (preg_match("/\.json$/", $filename)) {
  header("Content-Type: application/json");
} else if (preg_match("/\.appcache$/", $filename)) {
  header("Content-Type: text/cache-manifest");
}

$etag = "W/\"$file_hash\"";
header("ETag: $etag");

if (isset($_SERVER['HTTP_IF_NONE_MATCH']) && $etag == $_SERVER['HTTP_IF_NONE_MATCH']) {
  header( "HTTP/1.1 304 Not Modified" );
  return;
}

echo $contents;

?>